Hinweise zur Dokumentation

Diese Beschreibung wendet sich ausschließlich an ausgebildetes Fachpersonal der Steuerungs- und Automatisierungstechnik, das mit den geltenden nationalen Normen vertraut ist.
Zur Installation und Inbetriebnahme der Komponenten ist die Beachtung der Dokumentation und der nachfolgenden Hinweise und Erklärungen unbedingt notwendig.
Das Fachpersonal ist verpflichtet, für jede Installation und Inbetriebnahme die zu dem Zeitpunkt veröffentlichte Dokumentation zu verwenden.

Das Fachpersonal hat sicherzustellen, dass die Anwendung bzw. der Einsatz der beschriebenen Produkte alle Sicherheitsanforderungen, einschließlich sämtlicher anwendbaren Gesetze, Vorschriften, Bestimmungen und Normen erfüllt.

Disclaimer

Diese Dokumentation wurde sorgfältig erstellt. Die beschriebenen Produkte werden jedoch ständig weiter entwickelt.
Wir behalten uns das Recht vor, die Dokumentation jederzeit und ohne Ankündigung zu überarbeiten und zu ändern.
Aus den Angaben, Abbildungen und Beschreibungen in dieser Dokumentation können keine Ansprüche auf Änderung bereits gelieferter Produkte geltend gemacht werden.

Marken

Beckhoff®, TwinCAT®, EtherCAT®, EtherCAT G®, EtherCAT G10®, EtherCAT P®, Safety over EtherCAT®, TwinSAFE®, XFC®, XTS® und XPlanar® sind eingetragene und lizenzierte Marken der Beckhoff Automation GmbH.
Die Verwendung anderer in dieser Dokumentation enthaltenen Marken oder Kennzeichen durch Dritte kann zu einer Verletzung von Rechten der Inhaber der entsprechenden Bezeichnungen führen.

Patente

Die EtherCAT Technologie ist patentrechtlich geschützt, insbesondere durch folgende Anmeldungen und Patente:
EP1590927, EP1789857, EP1456722, EP2137893, DE102015105702
mit den entsprechenden Anmeldungen und Eintragungen in verschiedenen anderen Ländern.

EtherCAT® ist eine eingetragene Marke und patentierte Technologie lizenziert durch die Beckhoff Automation GmbH, Deutschland.

Copyright

© Beckhoff Automation GmbH & Co. KG, Deutschland.
Weitergabe sowie Vervielfältigung dieses Dokuments, Verwertung und Mitteilung seines Inhalts sind verboten, soweit nicht ausdrücklich gestattet.
Zuwiderhandlungen verpflichten zu Schadenersatz. Alle Rechte für den Fall der Patent-, Gebrauchsmuster- oder Geschmacksmustereintragung vorbehalten.


TcECAD_Overview

TS1120 | TwinCAT ECAD Import

Übersicht

Mit dem TwinCAT ECAD Import Tool ist die Engineering-Kette komplett: Von der Elektrokonstruktion bis zum SPS- Projekt funktioniert alles automatisch, ohne Eingriff. Die dadurch erzielte Minimierung von Eingabe- und Übertragungsfehlern reduziert letztendlich die Kosten.

Aus dem ECAD-Programm wird die notwendige Information über den Aufbau der I/Os und die Verknüpfung zu SPS-Variablen per XML exportiert. Der Aufbau der XML-Datei ist von Beckhoff in einem XML-Schema festgelegt. Das TwinCAT-ECAD-Import-Tool liest die XML-Datei und erzeugt eine TwinCAT System Manager Konfiguration mit allen I/O-Geräten, Busklemmen und Feldbusbox Modulen.

Ein Softwaregeräte-Hierarchie kann über den Import einer weiteren XML-Datei erzeugt werden. Ein NC-Gerät mit Tasks, Achsen und I/O-Variablen kann ebenfalls automatisch angelegt werden. Die Verknüpfungen zu SPS-Variablen können automatisch erzeugt werden. Ein Einspielen von Korrekturen in die ECAD-Konstruktionszeichnung ist zu beliebigen Zeitpunkten möglich. Notwendige Änderungen am TwinCAT System Manager und am SPS-Programm werden – soweit möglich – automatisch durchgeführt.

Umgekehrt kann das TwinCAT ECAD Import Tool eine spezielle XML Datei aus einer bestehenden TwinCAT System Manager Konfiguration erstellen. Dieses eröffnet einem ECAD Programm die Möglichkeit, Informationen aus I/O Konfigurationen zu lesen, und daraufhin ECAD Konstruktionszeichnungen zu erstellen, oder zu ändern.

Fig.1 Das Konzept des TwinCAT ECAD Tools.


TcECAD_News

Release Note

TcEcadImport Version 2.0.1.9

Veränderung des User Interface. Dem Teip Projekt sind neue Eigenschaften hinzugefügt worden.

IoGroup ist für die Variablen der EtherCAT Geräte iECAD2TwinCAT.xsdECAD2TwinCAT.xsd erweitert worden.

Link ist in Box und Klemme für die verknüpften NC/CNC Achsen, Encoder und Antriebe erweitert worden.

TcEcadImport Version 2.0.0.0

Neues Benutzer Interface.

Connection ist erweitert für EtherCAT Geräte in ECAD2TwinCAT.xsd.


TcECAD_Installation

Installation

Systemvoraussetzungen:

1) Windows NT\2000\XP.

2) TwinCAT Version 2.9 (Build 1030) oder höher

*Um EtherCAT benutzen zu können, muss die TwinCAT Version 2.11 installiert werden.

3) .Net Framework 3.5 SP1.


TcECAD_Overview

Einleitung

1. Wenn die Installation erfolgreich beendet wurde, finden Sie TcEcadImport unter Windows "Start" ->"Alle Programme" -> "TwinCAT System".

Nach dem Programmstart öffnet sich folgender Dialog:

Fig.1 Hauptdialog.

2. Erstellen Sie ein neues Projekt unter "File/New/Project "in der Menüleiste oder [image] in der Symbolleiste. Geben Sie dem Projekt einen Dateinamen. Der folgende Dialog zeigt den Inhalt eines TwinCAT ECAD Import Projekts (Teip):

Fig.2. TwinCAT ECAD Import Projekt (Teip) Dialog.

3. Bestätigen Sie die Eingabe der erforderlichen Einstellungen mit "OK". Die ECAD Dateien werden geladen oder vorbereitet. Die Ergebnisse werden in der Data View angezeigt. Die Fenster auf der rechten Seite zeigt die Details der ausgewählten ECAD Einträge an.

4. Wählen Sie in der Menüleiste "Action/Import ECAD to TwinCAT" oder [image] in der Symbolleiste. Die TwinCAT System Manager und PLC Control Dateien werden erzeugt bzw. aktualisiert. Nach Ausführung der Aktion erscheint eine Meldung. Die erzeugten/akualisierten TwinCAT Projektdateien können über "Tools/View tsm" oder "Tools/View pro" geöffnet werden.


TcECAD_UI_Overview

Hauptdialog

Der Hauptdialog besteht aus folgenden Teilen:

1) Menüleiste und Symbolleiste.

2) ECAD Datenansicht (Data View) und das Fenster Eigenschaften

3) Ausgang ( Output) Fehlerliste (Error List) und Befehlsfenster ( commands window)

4) Prozessleiste und Statusinformationen.

Fig.1 Hauptdialog


TcECAD_UI_Overview

Dialog TwinCAT ECAD Import Projekt (Teip)

Der folgende Dialog öffnet sich, wenn File/New/Project oder Project/Properties angewählt wird. In diesem Dialog kann entschieden werden, welche ECAD Import/Export Dateien und TwinCAT Projekt Dateien dem Projekt hinzugefügt werden.

Fig.1 Teip Dialog

Die Eingabe ist in vier Kategorien unterteilt:

1) General

Name : gibt den Namen des TwinCAT ECAD Import Projekts (Teip) an.

Author : Autor, optional.

2) TwinCAT

System Manager Project File for Import/Export: Dies ist zwingend erforderlich. Die Datei wird erzeugt/aktualisiert durch das Importieren der ECAD Datei. Oder eine ECAD Export Datei wird durch das Exportieren der TwinCAT Dateien erzeugt/aktualisiert.

PLC Control Project File for Import/Export : Dies ist zwingend erforderlich. Die Datei wird erzeugt/aktualisiert durch das Importieren der ECAD Datei. Oder eine ECAD Export Datei wird durch das Exportieren der TwinCAT Dateien erzeugt/aktualisiert.

3) Import

Import action option entscheidet, ob das TwinCAT Projekt wiederhergestellt (rebuild) oder aktualisiert (refreshed) wird.

Wenn Load available PLC projects TRUE ist wird das SPS Projekt nicht erzeugt, sondern nur für die verknüpften Variablen geladen.

Wenn Try to validate IoDataType with TwinCAT TRUE ist, wird der gegebene Datentyp in der ECAD mxl Datei durch die System Manager IO Variablen für gültig erklärt.

the given DataType in ECAD xml file will be validated with System Manager IO Variabel data types.

ECAD File for Import to TwinCAT : Dies ist zwingend erforderlich für ein Teip. Diese Datei ist vom ECAD Konstruktionszeichnungsprogramm bereitgestellt, welches Dateien exportiert, die dem Schema "ECAD2TWINCAT.xsd" entsprechen.

--- ECAD Device File for Import to TwinCAT: (Optional): Separate ECAD Datei, die nur die "Geräte" Information enthält.

Namig Rules File for Import to TwinCAT: Ist optional, wenn Regeln vorhanden sind, die spezielle Zeichen aus der ECAD Datei austauschen, z.B. "ue" gegen "ü".

4) Export

ECAD File for Export from TwinCAT : Hier muss entschieden werden, ob die TwinCAT System Manager und/oder PLC Control Projekt Dateien existieren, und ob eine ECAD Datei via das TwinCAT ECAD Import Tool exportiert werden soll.

Export exact type : Zeigt an, ob ein genauer Produkt Revisionstyp für das EtherCAT Gerät vorliegt, oder nicht.

Ingnore Index and SubIndex in IoName and IoGroup of Variables muss immer FALSE sein. Die genaue Variableninformation wird exportiert.


TcECAD_UI_Overview

TS1120 | TwinCAT ECAD Import

Dialog Rules Datei

Der folgende Dialog öffnet sich, wenn File/New/Rules or File/Open/Rules angewählt wird. In der Rules Datei können Regeln definiert werden, welche Zeichen in den Namen der Interfaces, Boxen, Klemmen IO Variablen oder SPS Variablen austauschen. Der Inhalt der ECAD Datei bliebt dabei unverändert. Diese Naming Rules Datei kann in das Teip eingefügt werden.


TcECAD_UI_Overview

Menü Datei (File)

Fig.1. Menü Datei

Das Menü Datei enthält folgende Punkte:

New/Project: Erzeugt ein neues TwinCAT ECAD Import Projekt (Teip), ( Symbolleiste [image]).

New Rules: Erzeugt eine neue Rules Datei. Der Rules Datei Dialog wird geöffnet.

Open/Project: Öffnet eine bestehende Teip Datei, (Symbolleiste [image]).

Open/Rules: Öffnet eine bestehende Rules Datei. Der Rules Datei Dialog wird geöffnet.

Save Project: Speichert die aktuell geöffnete Teip Datei (Symbolleiste [image]).

Save Project as...: Speichert die aktuell geöffnete Teip Datei unter einem neuen Namen.

Recent Projects: Zeigt eine Liste der zuletzt geöffneten Teip Dateien.

Close Project. Schließt das aktuell geöffnete Teip Projekt.

Exit: Ende des Programms.


TcECAD_UI_Overview

Menü Aktion (Action)

Fig.1. Menü Aktion

Das Menü Aktion enthält folgende Punkte::

Import ECAD to TwinCAT: Erzeugen/akualisieren der TwinCAT System Manager und PLC Control Projekt Daten durch Importieren einer ECAD Datei (Symbolleiste [image]).

Export ECAD from TwinCAT: Erzeugen/aktualisieren einer ECAD Datei gemäß des "ECAD2TWINCAT.xsd" Schemas mit der Erweiterung ".tc2ecad" (Symbolleiste [image]).

Refresh ECAD Data View/All: Erneutes Laden der ECAD Import Datei und Neustrukturierung der ECAD Export Daten der TwinCAT Projekte.

Refresh ECAD Data View/ECAD to TwinCAT: Erneutes Laden der ECAD Import Datei.

Refresh ECAD Data View/ECAD from TwinCAT: Neustrukturierung der ECAD Export Daten der TwinCAT Projekte.


TcECAD_UI_Overview

TS1120 | TwinCAT ECAD Import

Menü Projekt (Project)

Fig.1. Menü Projekt

Project/Properties: Öffnet den Eigenschaften Dialog für die aktuell geöffnete Teip Datei. Wenn die Eigenschaften verändert werden, werden die ECAD Daten aktualisiert.

Fig.2. Dialog Eigenschaften


TcECAD_UI_Overview

Menü Tools

Fig.1. Menü Tools

Tools/View tsm: Öffnet die TwinCAT System Manager Projekt Datei, die in der aktuell geöffneten Teip Datei enthalten ist.

Tools/View pro: Öffnet die PLC Control Projekt Datei, die in der aktuell geöffneten Teip Datei enthalten ist.

Tools/View list of Io types: Zeigt eine Auflistung der System Manager IO Typen. Die entsprechenden ECAD Typen können überprüft werden.

Fig.2. IO Typ Auswahldialog


TcECAD_UI_Overview

TS1120 | TwinCAT ECAD Import

Menü Hilfe (Help)

Fig.1. Menü Hilfe.

Help/Contents: Öffnet dieses Dokument.

Help/About: Öffnet den nachfolgenden Dialog:


ECADexportXmlFile

ECAD Export XML Datei

Beim Importieren ist die ECAD Export XML Datei im Import Dialog erforderlich.

Sie enthält die erforderlichen Informationen über die Struktur der I/O´s und das Mapping der SPS Variablen. Beckhoff verwendet ein XML Schema zur Spezifizierung der Struktur der XML Datei. Diese Schemadatei nennt sich ECAD2TwinCAT.xsd und die entsprechende TcBaseTypes.xsd Datei befindet sich im installierten TcEcad Ordner.

Hier ein einfaches Beispiel einer ECAD Export XML Datei

<?xml version="1.0" encoding="UTF-8"?>

< Project >

< Name ><![CDATA[ SOME NAME XML ]]></ Name >

< Author ><![CDATA[ UNKOWN ]]></ Author >

< Version > 1.0 </ Version >

< Description ><![CDATA[ SOME DESCRIPTION ]]></ Description >

< ChangeDate > 2003-10-14T13:18:44 </ ChangeDate >

< CPUs >

< CPU >

< Name ><![CDATA[ CPU1 ]]></ Name >

< Interfaces >

< Interface >

< Name ><![CDATA[ FB1 ]]></ Name >

< Comment ><![CDATA[ Interfacekommentar ]]></ Comment >

< Type ><![CDATA[ FC2002 ]]></ Type >

< ChannelNo > 1 </ ChannelNo >

< Boxes >

< Box >

< Name ><![CDATA[ LBF1 ]]></ Name >

< Comment ><![CDATA[ BK2000 ]]></ Comment >

< Type ><![CDATA[ BK2000 ]]></ Type >

< BoxNo > 1 </ BoxNo >

< Variables >

< Variable >

< Name ><![CDATA[ byAF1Status ]]></ Name >

< IsInput > 1 </ IsInput >

< Comment ><![CDATA[ LWL-BUS-Koppler Klemmstelle 1 Festseite ]]></ Comment >

< IoName ><![CDATA[ State ]]></ IoName >

< IoDataType > BYTE </ IoDataType >

</ Variable >

</ Variables >

< Terminals >

< Terminal >

< Name ><![CDATA[ Q01 ]]></ Name >

< Comment ><![CDATA[ Terminalkommentar ]]></ Comment >

< Type ><![CDATA[ KL2032 ]]></ Type >

< Channels >

< Channel >

< Name ><![CDATA[ A01 ]]></ Name >

< Comment ><![CDATA[]]></ Comment >

< Variables >

< Variable >

< Name ><![CDATA[ bQHF1FormatbYSchnellMinus ]]></ Name >

< IsInput > 0 </ IsInput >

< Comment ><![CDATA[ Formatbearbeitung Y-Achse schnell minus ]]></ Comment >

< IoDataType > Bool </ IoDataType >

</ Variable >

</ Variables >

</ Channel >

< Channel >

< Name ><![CDATA[ A02 ]]></ Name >

< Comment ><![CDATA[]]></ Comment >

< Variables >

< Variable >

< Name ><![CDATA[ bQHF1FormatbYLangsMinus ]]></ Name >

< IsInput > 0 </ IsInput >

< Comment ><![CDATA[ Formatbearbeitung Y-Achse langsam minus ]]></ Comment >

< IoDataType > Bool </ IoDataType >

</ Variable >

</ Variables >

</ Channel >

</ Channels >

</ Terminal >

</ Terminals >

</ Box >

</ Boxes >

</ Interface >

< Interface >

< Name ><![CDATA[ FB1 ]]></ Name >

< Comment ><![CDATA[ Interfacekommentar ]]></ Comment >

< Type ><![CDATA[ FC2002 ]]></ Type >

< ChannelNo > 2 </ ChannelNo >

</ Interface >

</ Interfaces >

</ CPU >

</ CPUs >

</ Project >


ECAD2TWINCATxsd_Overview

TS1120 | TwinCAT ECAD Import

Übersicht

Diese XML Schemadatei definiert die Struktur der ECAD Export XML Datei.

Die Definitionen der einzelnen XML Elemente in ECAD2TwinCAT.xsd sind nachfolgend kurz beschrieben.
In den folgenden Grafiken sind die Elemente mit einer durchgehenden Umrandung erforderliche Elemente, wie z.B. Namen. Elemente mit einer gestrichelten Umrandung hingegen sind optional, z. B. alle Kommentare.


ECAD2TWINCATxsd_Project

TS1120 | TwinCAT ECAD Import

Project

Project ist das Grundelement.

Name, Author, Description müssen im Format <![CDATA[]]>. geschrieben werden.

DataTypes legen die im SPS Programm verwendeten Datentypen fest. Es kann in einer ECAD EXPORT XML Datei ignoriert werden, ebenso wie im Beispiel “AT002V2.xml”.


ECAD2TWINCATxsd_Cpu

TS1120 | TwinCAT ECAD Import

CPU

CPUs enthält bislang nur ein CPU Element. Diese CPU gehört zum TwinCAT System Manager Projekt.


Devices

Device definiert die verschiedenen Konfigurationen im TwinCAT System Manager, z. B. ein SPS Projekt oder eine NC Achse.

Nachfolgend ein Beispiel für ein SPS Projekt:

< Device >

< Name ><![CDATA[ AT002 ]]></ Name >

< Comment />

< Type > PLC </ Type >

< Address > 801 </ Address >

< Modules />

< Tasks >

< Task >

< Name ><![CDATA[ Standard ]]></ Name >

< Comment ><![CDATA[ Task des IEC61131 Projekts "AT002" ]]></ Comment >

< Type > PLC </ Type >

< Calls >

< ProgramCall > Main () </ ProgramCall >

</ Calls >

< Priority > 0 </ Priority >

< CycleTime > 10000 </ CycleTime >

</ Task >

</ Tasks >

</ Device >

Und ein Beispiel für eine NC Achskonfiguration:

< Device >

< Name ><![CDATA[ NC - Configuration ]]></ Name >

< Comment />

< Type > NC </ Type >

< Address > 500 </ Address >

< Modules >

< Module >

< Name ><![CDATA[ Achse 1 (Oberdruck) ]]></ Name >

< Comment />

< Type > NCAXIS </ Type >

< SubType > 2 </ SubType >

< ModuleNo > 1 </ ModuleNo >

< Childs >

< Child >

< Name ><![CDATA[ Achse 1 (Oberdruck)_Enc ]]></ Name >

< Comment />

< Type > NCENCODER </ Type >

< SubType > 4 </ SubType >

< ModuleNo > 1 </ ModuleNo >

< Variables >

< Variable >

< Name ><![CDATA[ Achse 1 (Oberdruck)_Enc_In^nInData1^nInData1[0] ]]></ Name >

< Comment />

< DataType > UINT16 </ DataType >

< IsInput > true </ IsInput >

< LinkedWith >

< Name ><![CDATA[ Counter ]]></ Name >

< DataType > UINT16 </ DataType >

< IsInput > true </ IsInput >

< Device > IO </ Device >

</ LinkedWith >

....

< /Modules >

< Tasks >

< Task >

< Name ><![CDATA[ NC-Task 1 SAF ]]></ Name >

< Comment />

< Type > NC SAF </ Type >

< Priority > 0 </ Priority >

< CycleTime > 4000 </ CycleTime >

</ Task >

< Task >

< Name ><![CDATA[ NC-Task 1 SVB ]]></ Name >

< Comment />

< Type > NC SVB </ Type >

< Priority > 1 </ Priority >

< CycleTime > 10000 </ CycleTime >

</ Task >

</ Tasks >

< /Device >


ECAD2TWINCATxsd_Box_Modules

Device\Modules

Modules sind eine Sammlung von NC Achsen und NC Kanäle im TwinCAT System Manager.

Der Type einer NC Achse soll"NCAXIS" sein, und der Type eines NC Kanals entsprechend "NCCHANNEL".

Der SubType einer NC Achse kann folgendermaßen aussehen:

1, für Kontinuierliche Achsen (Servo);

2, für Eil-/Schleichachsen (two speed);

3, für Low Cost Schrittmotorachsen (dig. I/O);

5, für Encoder Achsen (Virtuelle Achse)...

Die Variables befinden sich direkt unter einem LineMotion Modul. (in Bearbeitung).

Childs sind die gleichen ComponentTypen in der Schemadatei. Sie repräsentieren die Teilnehmer und zum Beispiel eine NC Achse.


ECAD2TWINCATxsd_Box_Modules

TS1120 | TwinCAT ECAD Import

Childs

Childs sind die gleichen ComponentTypen in der Schemadatei. Sie repräsentieren die Teilnehmer und zum Beispiel eine NC Achse.

Der Type für Achsenencoder soll "NCENCODER" sein, entsprechend "NCDRIVE" für einen Achsantrieb und "NCCONTROLLER" für einen Achscontroller.

Der SubType für Simulations-Encoder sollte beispielsweise "1" sein.


ECAD2TWINCATxsd_Box_Modules

Variables

Variables sind die gleichen ComponentTypen in der Schemadatei. Sie repräsentieren die Teilnehmer und zum Beispiel eine NC Achse.

Der Type für Achsenencoder soll "NCENCODER" sein, entsprechend "NCDRIVE" für einen Achsantrieb und "NCCONTROLLER" für einen Achscontroller.

Der SubType für Simulations-Encoder sollte beispielsweise "1" sein.

LinkedWith definiert die Variable, die mit dieser Variable gemappt ist. Die gemappte Variable kann sich in der SPS, NC oder der IO Konfiguration befinden.

Somit muss "PLC1","PLC2","PLC3","PLC4", "PLC" als Defaulteinstellung von "PLC1, oder "NC", "LM", "IO" im Device Tag eingefügt werden.


ECAD2TWINCATxsd_Box_Modules

Tasks

Tasks sind eine Sammlung von Tasks unter einer SPS, NC, LineMotion und so weiter.

Der Name ist der Name des Tasks, z.B. "T1_Slow".

Der Type sollte "PLC" für SPS Tasks sein, entsprechend "NC SAF" für NC SAF Tasks und "NC SVB" für NC SVB Tasks, u.s.w.

Calls sind die Programme, die die Tasks aufrufen, z. B.

<Calls>
<ProgramCall>Main()</ProgramCall>
</Calls>


ECAD2TWINCATxsd_Interface

Interfaces

Interfaces legt die Feldbuskarte unter I/O Devices in der TwinCAT System Manager Konfiguration fest.

Zweikanalige Feldbuskarten werden im TwinCAT System Manager wie zwei einkanalige Feldbuskarten behandelt. Im diesem Fall kann der Name des Feldbusses gleich sein, die ChannelNo muss aber verschieden sein.
Wenn eine XML Datei importiert wird, um damit die TwinCAT System Manager Konfiguration zu erstellen, werden zwei Karten mit dem Namen Name_ChannelNo im TwinCAT System Manager angelegt.
Zum Beispiel gehört eine Schnittstelle in einer XML Datei mit Name= FB, ChannelNo=1 zu einem I/O Gerät mit dem Namen “FB_1”.

Wie im TwinCAT System Manager gebräuchlich, können die Ein- und Ausgänge einer Feldbuskarte direkt mit den SPS Variablen gemappt werden. Diese Information kann ebenfalls in der XML Datei enthalten sein, wie im nächsten Abschnitt erläutert.

Boxes definieren die Buskoppler, die mit der Feldbuskarte verbunden sind.


ECAD2TWINCATxsd_Variable

Variables

Variable kann an den unterschiedlichen Stellen auftreten: Interfaces, Boxes und Channels.

Name ist der gemappte SPS oder NC Variablenname.

IoName ist der Name, der im TwinCAT System Manager angezeigt wird.Für den Fall, dass sichVariable unterInterface undBox befindet, muss der IoName mit dem im TwinCAT System Manager identisch sein.

IoDataType ist der IEC Datentyp der SPS Variablen.

IsInput wird zur Definition der Variablen in TwinCAT PLC Control verwendet.

Zum Beispiel in einem SPS Projekt:

myInVar AT%I* : BOOL;
myOutVar AT%Q* : BOOL;

zeigt %I den Eingang und %Q den Ausgang an.

Instance wird zum Mapping der Gerätevariablen NC oder SPS verwendet.

Für NC sollte der Name wie der Modulname lauten, wie z.B. "Axis1" oder "Axis1^Axis_Enc"

Für SPS wird zukünftig das Mappen von non-globalen SPS Variablen, z.B. eine Variable eines Funktionsblock möglich sein (in Bearbeitung).

Destination definiert in welches Gerät und Task die Variable gemappt werden soll.

Beispiel für eine Variable:

<Variable>
<Name><![CDATA[nInData1[0]]]></Name>
<IsInput>true</IsInput>
<IoName>Counter</IoName>
<IoDataType>UINT16</IoDataType>
<Instance>
<Name><![CDATA[Achse 1 (Oberdruck)^Achse 1 (Oberdruck)_Enc]]></Name>
<DataType>UINT16ARR2</DataType>
<IsInput>true</IsInput>
</Instance>
<Destination>
<Device>NC</Device>
<Task>NC-Task 1 SAF</Task>
</Destination>
</Variable>

Beispiel für die entsprechende gemappte Variable im Gerät:

<Variable>
<Name><![CDATA[Achse 1 (Oberdruck)_Enc_In^nInData1^nInData1[0]]]></Name>
<DataType>UINT16</DataType>
<IsInput>true</IsInput>
<LinkedWith>
<Name><![CDATA[Counter]]></Name>
<DataType>UINT16</DataType>
<IsInput>true</IsInput>
<Device>IO</Device>
</LinkedWith>
</Variable>

Info:

Die Variable unter Channel unterscheidet sich teilweise von der unter Interface oder Box. Unter einem Channel ist generell nur eine ( z.B. im Falle einer digitalen Busklemme), oder nur eine interessante Variable.
In diesem Fall kann IoName frei benannt werden und IsInput kann ausgelassen werden.

Wenn jedoch eine andere als die Default I/O-Variable unter Channel mit einer SPS Variablen gemappt werden soll, muss IoName mit dem Namen im TwinCAT System Manager identisch sein.

Neu: Ab der Version 2.0.1.9, sind folgende Ergänzungen für die EhterCAT Slaves hinzugekommen:

IoGroup ist für die EtherCAT Slave Variablen verbindlich. Es ist der Name der Variablengruppe, wie im folgenden Bild zu sehen ist. IoGroup kann das Attribut Index besitzen. Dieses sollte mit dem Index des PDO Eintrags identisch sein.

IoName kann nun optional die Attribute Index, SubIndex and IndexInArray besitzen. Diese sollten identisch sein mit den Attributen der Einträge der Prozessdaten der EtherCAT slaves. IndexInArray ist notwendig, wenn die Variable ein Arrayelement ist.


ECAD2TWINCATxsd_Box

Boxes

Boxes beschreibt die Boxen im TwinCAT System Manager, z. B. einen Feldbus Koppler. Ab der Version 2.0.0.0 werden alle EtherCAT Teilnehmer wie der Typ Box behandelt.

Name und Comment besitzen den gleichen Inhalt wie Name und Comment (Kommentar) im TwinCAT System Manager.
Type sollte die Abkürzung des Namens in der Datei TcTerminals.xml sein.

Type ist notwendig, damit der TwinCAT System Manager die korrekte Box anfügen kann. Normalerweise ist dies einfach die Abkürzung des Typs, der im TwinCAT System Manager angezeigt wird (z.B. BK2000).

Hinweis :

1.) Das Interface der EtherCAT Boxen muss vom Typ "ETHERCAT" sein. Der Typ der EtherCAT Box kann als komplette Typbezeichnung oder im Kurzformat angegeben werden. Zum Beispiel BK1120-0000-9998" ist die genaue Typbezeichnung für einen BK1120, die im Karteireiter EtherCAT einer EtherCAT Box zu finden ist. Wenn das Kurzformat "BK1120" angegeben ist, wird automatisch die aktuellste Revision importiert (z.B. "BK1120-0000-0000")

Für EtherCAT Boxen muss der Produkt- /Revisionscode im Tag <Type> angegeben werden. Alle Schnittstellen dieser Box müssen vom Typ "ETHERCAT" sein.

Wie im folgenden Beispiel zu sehen, ist der Produkt- /Revisionscode für den BK1120 "BK1120-0000-9998". Diese Einstellung finden Sie auf dem EtherCAT Karteireiter der EtherCAT Box Einstellungen.

Der Produkt- /Revisionscode wird in der ECAD XML Datei folgendermaßen dargestellt:

< Interfaces >

< Interface >

< Name ><![CDATA[ FB1_1 ]]></ Name >

< Comment />

< Type > ETHERCAT </ Type >

< Boxes >

< Box >

< Name ><![CDATA[ BKF33 ]]></ Name >

< Comment />

< Type > BK1120-0000-9998 </ Type >

< BoxNo > 5 </ BoxNo >

< Terminals >

...

Für Fremdprodukte muss der Code in dem Format:" V%8X_P%8X_R%8X_S%8X" angegeben werden.

z.B. V00000002_P04602C22_R270E0000

V: Herstellercode, ( das ist 2 für Beckhoff Produkte)

P: Produktcode.

R: Revisionsnummer, optional

S: Seriennummer, optional

%8X: Nummer im hex Format mit der Länge 8.

2) Für Profibus Boxen gilt: Wenn die Profibus Box ein Beckhoff Gerät ist, sollte "BK3XXX" als <Type> tag angegeben werden. Andernfalls ist "PBDP_GSD" einzugeben.

Um die genauen Typ Informationen angeben zu können, muss der Produktname oder Modulname in der GSD Datei im Tag <ProductName> und <AdditionalInfo> enthalten sein, z.B. IL230x-B310 ( im Beckhoff Katalog enthalten).

< Interfaces >

< Interface >

< Name ><![CDATA[Pos.650 Sorter201 (FC310x)]]></ Name >

< Comment />

< Type >FC3100</ Type >

< Boxes >

< Box >

< Name ><![CDATA[ Coupler box IL230x-Bxxx ]]></ Name >

< Comment />

< AdditionalInfo >

< ProductName > IL2302-B310 </ ProductName >

< / AdditionalInfo >

< Type >BK3XXX</Type>

< BoxNo > 5 </ BoxNo >

< Terminals >

...

Im Kapitel AdditionalInfo finden Sie weitere Informationen.

BoxNo ist die physikalische Lage der Box, identisch mit der Nummer der “Id:” im TwinCAT System Manager.

Hinweis:

Für den Beckhoff Lightbus ist die Beachtung der Lage sehr wichtig, im Gegensatz zum Profibus.

Connection enthält Informationen zur Verbindung der EtherCAT Box. Es ist besonders nützlich für EtherCAT Boxen, die mehr als einen EtherNet port enthalten, wie zum Beispiel EtherCAT EK1122.

Variables definieren die gemappten I/O Variablen einer Box und der SPS Variablen, wie im letzten Abschnitt enthalten.

Terminals repräsentieren die I/O Klemmen, die zu einer Box hinzugefügt wurden.

AdditionalInfo und Modules werden optional für Nicht-Beckhoff Produkte verwendet.

AdditionalInfo bietet Informationen zu Produkten wie Profibus (.gsd) und DeviceNet (.eds).

Modules gibt Informationen z.B. zum Profibusmodul.

Link enthält Informationen der verknüpften NC/CNC Achsen, Encoder oder Antriebe der Box..


ECAD2TWINCATxsd_AdditionalInfo

AdditionalInfo

Der ProductName muss die gleiche Bezeichnung haben, wie der Modulname (Model_name) in der GSD Datei, oder der Produktname (ProdName) in der EDS Datei. Wenn es sci um ein Beckhoff Produkt handelt, kann die Produktbezeichnung aus dem Beckhoff Katalog verwendet werden.

Die detaillierte Information kann auf zwei Arten angegeben werden: Einmal über den absoluten Path (Pfad) des Dateinamens, oder eingebunden in die gesamte Datei im ConfigFile, wie das nachfolgende Beispiel zeigt:

<Interface>
<Name><![CDATA[Device 1 (CX1500-M310)]]></Name>
<Type>CX1500_M310</Type>
<ChannelNo>1</ChannelNo>
<Boxes>
<Box>
<Name><![CDATA[Bosch-VI1 (GSD Box) (RMVDP/F)]]></Name>
<Comment><![CDATA[Vendor: Robert Bosch GmbH, 64701 Erbach Revision: 1.0]]></Comment>
<AdditionalInfo>
<ProductName>RMVDP/F</ProductName>
<Path>C:\GSDBox\Rb010118.gsd</Path>
<ConfigFile><![CDATA[

;************************************************************************
;*** ***any commons....

;************************************************************************
;*************************************************************************
;
#Profibus_DP
;
;*************************************************************************
; Allgemeine Daten
;*************************************************************************
;
;Versionskennung des GSD-Dateiformats
GSD_Revision = 2
;
; Herstellername
Vendor_Name = "Robert Bosch GmbH, 64701 Erbach"
;
; Geraetebezeichnung
Model_Name = "RMVDP/F"
;
; Ausgabestand des DP-Geraetes
Revision = "1.0"
;
; Typnummer
Ident_Number = 0x0118
;
; Protokollkennung
Protocol_Ident = 0
;
; DP-Geraetetyp
Station_Type = 0
;
; Hardware-Ausgabestand
Hardware_Release = "V1.0"
;
; Software-Ausgabestand
Software_Release = "----"
;
; Unterstuetzte Baudraten
9.6_supp = 1
19.2_supp = 1
93.75_supp = 1
187.5_supp = 1
500_supp = 1
1.5M_supp = 1
3M_supp = 1
6M_supp = 1
12M_supp = 1
;
; Maximale Protokoll-Bearbeitungszeit
MaxTsdr_9.6 = 60
MaxTsdr_19.2 = 60
MaxTsdr_93.75 = 60
MaxTsdr_187.5 = 60
MaxTsdr_500 = 100
MaxTsdr_1.5M = 150
MaxTsdr_3M = 250
MaxTsdr_6M = 450
MaxTsdr_12M = 800
;
;Geraeteunterstuetzung redundanter Uebertragungstechnik
Redundancy = 0
;
; Pegel des Repeater-Steuersignals CNTR-P
Repeater_Ctrl_Sig = 0
;
; Bitmap-Datei
Bitmap_Device = "RBxxRM_M"
;
; Realisierungs-Typ LSPM2 Version B
Implementation_Type = "LSPM2-B"
;
;*************************************************************************
; spezifische Daten des Busteilnehmers
;*************************************************************************
;
; DP-Geraet unterstuetzt den Freeze-Mode
Freeze_Mode_supp = 1
;
; DP-Geraet unterstuetzt den Sync-Mode
Sync_Mode_supp = 1
;
; Automatische Baudratenerkennung
Auto_Baud_supp = 1
;
; Unterstuetzung der Busteilnehmer-Adressierung
Set_Slave_Add_supp = 0
;
; Hoechstlaenge des herstellerspezifischen Feldes
User_Prm_Data_Len = 0x05
;
; Herstellerspezifisches Feld
User_Prm_Data = 0x00,0x00,0x00,0x00,0x00
;
; Minimaler Abstand zwischen zwei Zugriffen auf den Busteilnehmer
Min_Slave_Intervall = 1
;
; Busteilnehmertyp
Modular_Station = 1
;
; Hoechstanzahl der Module einer modularen Station
Max_Module = 1
;
; Hoechstlaenge der Eingangsdaten einer modularen Station in Bytes
Max_Input_Len = 0
;
; Hoechstlaenge der Ausgangsdaten einer modularen Station in Bytes
Max_Output_Len = 4
;
; Groesste Summe der Laengen der Ein- und Ausgangsdaten einer modularen Station
Max_Data_Len = 4
;
;Geraetespezifische Diagnosemeldungen
Unit_Diag_Bit(0) = "Kurzschluss Ventile"
Unit_Diag_Bit(1) = "Unterspannung UQ1"
Unit_Diag_Bit(2) = "Unterspannung UQ2"
Unit_Diag_Bit(3) = "UQ1 nicht vorhanden"
Unit_Diag_Bit(4) = "UQ2 nicht vorhanden"
;
; Hoechstlaenge der Diagnoseinformation (Diag_Data)
Max_Diag_Data_Len = 13
;
; Funktionsklasse: I/O
Slave_Family = 3@Bosch
;
; Modulkennung
;------------------------------------------------------------------------------
;
Module = "Ventile 1-16" 0x23, 0x00
0
EndModule
Module = "KT-Ventile 1-12" 0x22, 0x00
1
EndModule
;
;********************* Ende der Geraetestammdatendatei *********************

]]>

</ConfigFile>
</AdditionalInfo>
<Type>PBDP_GSD</Type>
<BoxNo>1</BoxNo>
<Modules>
<Module>
<Name><![CDATA[Ventile 1-16]]></Name>
<Comment/>
<Type>0</Type>
<Variables>
<Variable>
<Name><![CDATA[]]></Name>
<IsInput>false</IsInput>
<Comment/>
<IoName>Ventile 1-16_1_0</IoName>
<IoDataType>BYTE_ARRAY_0_3</IoDataType>
</Variable>

.....


ECAD2TWINCATxsd_AdditionalInfo

Connection

Dieses Element ist nur erforderlich, wenn es einen EtherCAT Teilnehmer gibt, der mehr als zwei Ethernet Ports besitzt. Die EtherCAT Abzweigung "EK1122" zum Beispiel hat zwei Ports, gekennzeichnet mit "X1" und "X2". Individuelle Geräte oder komplette EtherCAT Endhülsen können mit den Anschlussports verbunden werden. TwinCAT ECAD Import muss dann wissen, welches Geräte mit welchem Anschlussport verbunden ist. Aus diesem Grund muss in der ECAD Datei eine eindeutige ConnectId für EK1122 vergeben werden. Die PreviousID (vorherige Id) und der PrevoiusPort müssen für die verzweigten Geräte angegeben werden.

Ein Beispiel sehen Sie hier:

<Interface>
<Name><![CDATA[Device 1 (EtherCAT)]]></Name>
<Type>ETHERCAT</Type>
<ChannelNo>1</ChannelNo>
<Boxes>

...
<Box>
<Name><![CDATA[Term 12 (EK1122)]]></Name>
<Type>EK1122-0000-0016</Type>
<BoxNo>1012</BoxNo>
<Connection>
<ConnectId>1012</ConnecId>

<Connection>

....

</Box>

<Box>
<Name><![CDATA[Term 40(EK1100)]]></Name>
<Type>EK1100-0000-0001</Type>
<BoxNo>1040</BoxNo>
<Connection>
<PreviousId>1012</ConnecId>

<PreviousPort>X1</ConnecId>

<Connection>

....

</Box>


TCPlcLibCX1000System_Terminals

Terminals

Terminals enthält eine Auflistung der Busklemmen.

Type ist der Klemmentyp.

Die Klemmentypnummer, die der TwinCAT System Manager für das Anfügen von Klemmen verwendet, ist die Nummer der Klemmenbezeichnung (KL2004->2004). Eine Ausnahme bilden die Klemmen mit einen Subtyp:
Klemmen gibt es komplex und kompakt. Kompakte Klemmen enthalten auch nur eine Variable. Komplexe Klemmen haben zusätzlich noch weitere Variablen für Status undDiagnose.Klemmen mit einem Subtyp besitzen eine erweiterte Bezeichnung, z.B. "KL3001 -1&quot.

Channels enthält die Kanäle der Klemmen.

Lin k enthält Informationen der verknüpften NC/CNC Achse, des Encoders oder Antriebs einer Klemme.


ECAD2TWINCATxsd_Channels

TS1120 | TwinCAT ECAD Import

Channels

Name und Comment werden einfach in den TwinCAT System Manager übernommen.

Ein Channel kann eine oder mehrere Variablen enthalten. Einfache digitale klemmen haben mehrere Kanäle, die immer nur eine Variable enthalten. Analoge Klemmen gibt es komplex und kompakt. Kompakte Klemmen enthalten auch nur eine Variable. Komplexe Klemmen haben zusätzlich noch weitere Variablen für Status und Konfiguration. Andere intelligente Klemmen haben nur einen Kanal, darin aber viele Variablen z.B: die serielle Klemme KL6000-A-1.


ECAD2TWINCATxsd_Box_Modules

TS1120 | TwinCAT ECAD Import

Box\Modules

Modules unter einer Box sind vergleichbar mit den Terminals ohne Channels (Kanäle). Die Variables befinden sich direkt unter einem Module. Sie werden nur für GSD Dateien verwendet.


TCPlcLibCX1000System_Terminals

Link in Box and Terminal

Link enthält Informationen über die verknüpften NC oder CNC Achsen, Encoder oder Antriebe einer Box bzw. Klemme

<Box>
<Name><![CDATA[BKF21_I20 (OF1-Einzug Messrad)]]></Name>
<Comment><![CDATA[]]></Comment>
<Type>EL5151</Type>
<BoxNo>8</BoxNo>
<Connection>
<ConnectId>1007</ConnectId>
<PreviousId>1006</PreviousId>
</Connection>
<Link AxisName="Achse 7 Servokanteneinzug T3 (OF1)" Target="Encoder" TargetId="2">NC</Link>
</Box>


ECAD2TWINCATxsd_Overview

TS1120 | TwinCAT ECAD Import

Beispiel: Daten aus Eplan P8 in TwinCAT verwenden

Die folgende Applikation bietet eine Lösung um Daten aus Eplan P8 in TwinCAT wiederverwenden zu können. Basis für diese Wiederverwertung ist eine durch Beckhoff definierte XML Datei. Das TwinCAT ECAD Import Tool nutzt dieses XML File um eine TwinCAT Konfiguration zu erzeugen.
Das Beispiel enthält ein EPLAN P8 Projekt und die exportierte XML Datei aus EPLAN, inklusive der daraus erstellten TwinCAT Konfiguration. Somit zeigt das Beispiel den kompletten Workflow der TwinCAT EPLAN Schnittstelle auf.

Download Beispiel


ECAD2TWINCATxsd_Overview

TS1120 | TwinCAT ECAD Import

Schnittstellenbeschreibung und Workflow

Hier finden Sie PDF Dateien zur Schnittstellenbeschreibung und zum Workflow des TwinCAT ECAD Import.


TcECAD_UI_Exporter

TwinCAT ECAD Tool

Export Dialog

Der Export Dialog wird verwendet, um Beckhoff-spezifische ECAD XML Dateien aus einer bestehenden TwinCAT System Manager Konfiguration zu erstellen. Die Vorgehensweise ist einfach: Geben Sie den Dateinamen des TwinCAT System Manager Projektes und der ECAD XML Datei ein. Optional können weitere Dateieigenschaften wie Name, Autor, Version und Beschreibung eingegeben werden. Durch Anwahl der Schaltfläche "Generate Ecad File” wird die Datei erstellt.

Bild 2. b

Kurze Erklärung der Dialogeinträge:

1) Ecad/Import: Zeigt Import Dialog, deaktiviert, wenn der Dialog aktiv ist.

2) Ecad/Export: Zeigt Export Dialog, deaktiviert, wenn der Dialog aktiv ist.

3) Ecad/Exit: Programmende.

4) Window/Close: Schließt das Import oder Export Fenster.

5) Help/Contents: Zeigt diese Information an.

6) Help/About: Anzeige der Kurzdokumentation.


TcECAD_UI_Importer

TwinCAT ECAD Tool

Import Dialog

Der Import Dialog wird dazu verwendet, ECAD XML Dateien zu lesen, um im TwinCAT System Manager die entsprechende Konfiguration und in TwinCAT PLC Control das zugehörige Programm erstellen zu können. Im Folgenden finden Sie dazu eine Kurzbeschreibung.

1) Klicken Sie im Menü auf File->New Project, oder in der Toolbar auf den Button [image] . Im Dialog “New ECAD Import Project” , der daraufhin angezeigt wird, ist der Projektname einzugeben. Bestätigen Sie die Eingabe mit “Save”.

2) Geben Sie die Namen für die Dateien ECAD XML, Devices XML (optional), System Manager Projekt, PLC Projekt und Rules (optional) in die entsprechenden Textboxen ein. Die Namen können entweder eingetippt werden, oder es kann mit der Schaltfläche ... am rechten Rand der Textbox danach gesucht werden.

Wenn Sie für die Dateien des TwinCAT System Managers und TwinCAT PLC Projektes neue Namen vergeben , wird später automatisch eine neue *.tsm bzw. *.pro Datei erstellt.

Bild 3 ECAD Import Projektbeispiel.

3) Klicken Sie im Menü Projekt->Update oder in der Toolbar auf den Button [image] . der Prozess wird nun gestartet,. Die Prozessinformationen und Fehlermeldungen, falls vorhanden, werden im unteren Teil des Fensters angezeigt.

4) Falls sich während der Prozessausführungszeit ein Dialog öffnet, müssen bestimmt Klemmentypen ausgewählt werden, um den Prozess fortzusetzen.

Kurze Erklärung der Dialogeinträge:

1) Ecad/Import: Zeigt Import Dialog, deaktiviert, wenn der Dialog aktiv ist.

2) Ecad/Export: Zeigt Export Dialog, deaktiviert, wenn der Dialog aktiv ist.

3) Ecad/Exit: Programmende.

4) File/New Project: Erzeugt ein neues ECAD Import Projekt (.teip)

5) File/Open Project: Öffnet ein bestehendes ECAD Import Projekt.

6) File/Close Project: Schließt das aktuelle ECAD import Projekt.

7) File/Save Project As…: Speichert das aktuelle ECAD Import Projekt unter einem anderen Namen.

8) File/Save all: Speichert das aktuelle ECAD Import Projekt und die Rules Datei, falls vorhanden.

9) File/New Rules: Erzeugt eine neue Rule Datei (.teir).

10) File/Save Rules: Speichert die aktuelle Rule Datei.

11) File/Save Rules As…: Speichert die aktuelle Rule Datei unter einem anderen Namen.

11) File/Recent Projects...: Listet die letzten 10 Projekte auf.

12) Project/Update: Update der erzeugten TwinCAT System Manager Konfiguration und des TwinCAT PLC Projekts.

13) Project/Rebuild: Wiederherstellung der TwinCAT System Manager Konfiguration und des TwinCAT PLC Projekts.

*Hinweis: Das Update wird immer zunächst das Backup der letzten XML Datei mit der aktuellen XML Datei vergleichen. Wenn das Import Projekt eine ECAD XML Datei enthält, die von der letzten Datei abweicht, sollte ein Rebuild durchgeführt werden.

14) Window/Close: Schließt das Import oder Export Fenster.

15) Help/Contents: Zeigt diese Information an.

16) Help/About: Anzeige der Kurzdokumentation.

Rules

Wenn ein ECAD Import Projekt geöffnet ist, kann eine Rules Datei erzeugt oder geöffnet werden.

Die Rules können dazu verwendet werden, Schnittstellen, Boxen, Klemmen, I/O´s oder SPS Variablen umzubenennen, z.B. durch Ersetzen von "ö" durch "oe", wie im nachfolgenden Bild dargestellt..

Bild.4 Rules Karteireiter


TcECAD_UI_Overview

TwinCAT ECAD Tool

Übersicht

Nach erfolgreicher Installation befindet sich TcEcad im Windows Startmenü "Alle Programme" "unter "TwinCAT System". Nach dem Programmstart öffnet sich der folgende Dialog:

Bild.1 Start Dialog.

In diesem Karteireiter kann der Funktionstyp gewählt werden. Beachten Sie bitte, dass die Begriffe "Import" und "Export" aus der Sicht des TwinCAT System Managers definiert sind.

Abhängig von den unterschiedlichen Funktionstypen wird einer der beiden unteren Dialoge angezeigt.

Bild2 (a) Import Dialog.

Bild2 (b) Export Dialog.